#include <iostream>
#include <fstream>
#include <string.h>

using namespace std;

long long ans[32][5000];

long long doit( int n, int m )
{
    if( !m && n ) return 0;
    if( n == 1 ) return m;
    if( n < 0 ) return 0;
    if( !n )
    {
        if( m ) return 1LL;
        return 0LL;
    }
    
    if( ans[n][m] < 0 )
    {
        ans[n][m] = 0;
        for( int i = m; i > 0; i-- )
        {
            ans[n][m] += doit( n - 1, i / 2 );
        }
    }
    return ans[n][m];
}

int main()
{
    memset( ans, -1, sizeof( ans ) );
    ifstream cin( "c.in", ios::in );
    int N;  cin >> N;
    int prob = 0;
    while( N-- )
    {
        int n, m;
        cin >> n >> m;
        long long  ans = doit( n, m );
        printf( "Case %d: n = %d, m = %d, # lists = %Ld\n", ++prob, n, m, ans );
    }
    return 0;
}
