#include <iostream>
#include <fstream>
#include <string.h>
#include <math.h>

using namespace std;

int mo[128];
double amt[128];
double p[128];

int main()
{
    ifstream cin( "i.in", ios::in );
    int n, prob = 0;
    while( cin >> n && n >= 0 )
    {
        for( int i = 0; i < n; i++ ) cin >> mo[i] >> amt[i];
        int endd;
        double endAmt;
        cin >> endd >> endAmt;
        
        memset( p, 0, sizeof( p ) );
        for( int i = 0; i < n; i++ )
        {
            p[endd - mo[i] + 1] += amt[i];
        }
                
        double L = 1.0, R = 2.0, mid;
        while( R - L > 1e-7 )
        {
            mid = ( R + L ) * 0.5;
            double v = 0;
            for( int i = 1; i <= 16; i++ )
            {
                v += pow( mid, i ) * p[i];
            }
            
            if( v > endAmt ) R = mid;
            else L = mid;
        }
        if( prob ) printf( "\n" );
        printf( "Case %d: %.5f\n", ++prob, mid - 1.0 );
    }
    return 0;
}
